package eu.lindenbaum.maven.mojo.app;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on maven-erlang-plugin.<br/> Call <pre>  mvn erlang:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Fri Mar 18 09:30:33 CET 2011
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.7)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "eu.lindenbaum:maven-erlang-plugin:2.0.0", 0 );
        append( sb, "", 0 );

        append( sb, "Maven Erlang Plug-In", 0 );
        append( sb, "Maven2 Plug-In to manage Erlang projects.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 26 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "compile".equals( goal ) )
        {
            append( sb, "erlang:compile", 0 );
            append( sb, "This Mojo compiles the projects erlang sources.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "compilerOptions", 2 );
                append( sb, "Additional compiler options (comma separated) for compilation that are directly passed to compile:file/2, e.g. \'debug_info, nowarn_unused_function\'. Note: The user may not specifiy one of the report options since the Mojo itself uses the return option internally. Warnings and Errors will be printed without specifying extra options.", 3 );
                append( sb, "Expression: ${compilerOptions}", 3 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "coverage".equals( goal ) )
        {
            append( sb, "erlang:coverage", 0 );
            append( sb, "Generates a test coverage report with: project summary, showing the number of functions, clauses executable lines and their test coverage percentage. A module list with individual coverage reports and an extensive source code report, with lines annotated in red or green, showing the exact coverage.\nISSUE If a test purges or unloads a module to do coverage for, the coverage compilation information will be gone and the coverage report will fail.\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );

                append( sb, "silent (Default: false)", 2 );
                append( sb, "Setting this to true will supress the console output and only generate the coverage report output HTML file.", 3 );
                append( sb, "Expression: ${silent}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "dialyzer".equals( goal ) )
        {
            append( sb, "erlang:dialyzer", 0 );
            append( sb, "This Mojo runs the erlang dialyzer tool on the project sources as well as the project includes. This means dialyzer will run over the complete project code (excluding test modules).\n\nThe dialyzer can be skipped using the skipDialyzer parameter. Additionally, the user can choose to run dialyzer also on the projects dependencies using the dialyzerWithDependencies parameter. This is disabled by default for the erlang-otp and erlang-std project packaging.\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "dialyzerOptions", 2 );
                append( sb, "Additional dialyzer warning options. This must be a comma separated list with valid warning atoms that will be included when calling dialyzer:run([{warnings,[...]}, ...]).", 3 );
                append( sb, "Expression: ${dialyzerOptions}", 3 );
                append( sb, "", 0 );

                append( sb, "dialyzerWarningsAreErrors (Default: false)", 2 );
                append( sb, "Setting this to true will break the build when a dialyzer run returns warnings.", 3 );
                append( sb, "Expression: ${dialyzerWarningsAreErrors}", 3 );
                append( sb, "", 0 );

                append( sb, "dialyzerWithDependencies (Default: false)", 2 );
                append( sb, "Setting this to true will include the projects dependencies into the dialyzer run. Note: This may take very long.", 3 );
                append( sb, "Expression: ${dialyzerWithDependencies}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );

                append( sb, "skipDialyzer (Default: false)", 2 );
                append( sb, "Setting this to true will skip the dialyzer analysis.", 3 );
                append( sb, "Expression: ${skipDialyzer}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "dialyzer-release".equals( goal ) )
        {
            append( sb, "erlang:dialyzer-release", 0 );
            append( sb, "This Mojo runs the erlang dialyzer tool on the release dependencies. The dialyzer can be skipped using the skipDialyzer parameter.\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "dialyzerOptions", 2 );
                append( sb, "Additional dialyzer warning options. This must be a comma separated list with valid warning atoms that will be included when calling dialyzer:run([{warnings,[...]}, ...]).", 3 );
                append( sb, "Expression: ${dialyzerOptions}", 3 );
                append( sb, "", 0 );

                append( sb, "dialyzerWarningsAreErrors (Default: false)", 2 );
                append( sb, "Setting this to true will break the build when a dialyzer run returns warnings.", 3 );
                append( sb, "Expression: ${dialyzerWarningsAreErrors}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );

                append( sb, "skipDialyzer (Default: false)", 2 );
                append( sb, "Setting this to true will skip the dialyzer analysis.", 3 );
                append( sb, "Expression: ${skipDialyzer}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "edoc".equals( goal ) )
        {
            append( sb, "erlang:edoc", 0 );
            append( sb, "This Mojo will generate source code documentation for an application.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "extract-dependencies".equals( goal ) )
        {
            append( sb, "erlang:extract-dependencies", 0 );
            append( sb, "Unpack erlang-otp or erlang-std dependencies. This will unpack all dependencies of this MavenProject into the target/lib directory. This is done only in case the dependency has changed since the last unpack process.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "generate-release-resources".equals( goal ) )
        {
            append( sb, "erlang:generate-release-resources", 0 );
            append( sb, "Copies all resource files into that target directory structure. Copied resources contain:\n-\trelease file (*.rel)\n-\trelease upgrade file (relup)\n-\tboot scripts, etc. as returned from systools:make_script\nThe build of script files can be customized by passing user options through the scriptOptions parameter. In order to manage the project over the project pom there is the possibility to let the Mojo automatically fill in values from the project pom into the .rel file. This can be done by using one of the supported variables into the release file. Below is a list of supported variables and their substitutions:\n\n\n-\t${ARTIFACT}: the projects artifact id (atom)\n-\t${VERSION}: the projects version (string)\n-\t${ERTS}: expands to the tuple {erts, \'ERTS_VERSION\'} with the version of erts available on the backend node (tuple)\n-\t${APPLICATIONS}: a comma separated listing with all transitive dependency applications of the project (tuple listing)\n-\t${AUTODEPS}: an erlang list with all transitive dependency applications of the project (list)\n-\t${APPLICATION_NAME}: will be replaced by the tuple {\'APPLICATION_NAME\', \'APPLICATION_VERSION\'} with the version available on the backend node (tuple)\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );

                append( sb, "scriptOptions", 2 );
                append( sb, "Additional options for systools:make_script/2 (comma separated). Note: The silent option is passed by the plugin, do not overwrite.", 3 );
                append( sb, "Expression: ${scriptOptions}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "generate-resources".equals( goal ) )
        {
            append( sb, "erlang:generate-resources", 0 );
            append( sb, "Copies all resource files into that target directory structure. Copied resources contain:\n-\terlang source files (*.erl)\n-\terlang include files (*.hrl)\n-\tedoc overviews (overview.edoc)\n-\tresources (*)\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "generate-test-resources".equals( goal ) )
        {
            append( sb, "erlang:generate-test-resources", 0 );
            append( sb, "Copies all test resource files into that target directory structure. Copied resources contain:\n-\tresources (*)\n-\ttest resources (*)\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );

                append( sb, "skipTests (Default: false)", 2 );
                append( sb, "Setting this to true will skip copying the test resources.", 3 );
                append( sb, "Expression: ${skipTests}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "erlang:help", 0 );
            append( sb, "Display help information on maven-erlang-plugin.\nCall\n\u00a0\u00a0mvn\u00a0erlang:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "initialize".equals( goal ) )
        {
            append( sb, "erlang:initialize", 0 );
            append( sb, "Mojo that starts the erlang node used as a backend for rpcs made by the plugin. The node will only be started if it is not already running. The node will be shutdown when the executing JVM exits. This is done by a Runtime.addShutdownHook() which will only be added once each JVM execution.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "package".equals( goal ) )
        {
            append( sb, "erlang:package", 0 );
            append( sb, "This Mojo packages all application artifacts into a single .tar.gz package. This includes .beam files, the .hrl include files and private data from the priv directory.\n\nBesides that this Mojo also copies the erlang application resource file. In order to manage the project over the project pom there is the possibility to let the Mojo automatically fill in values from the project pom into the .app and .appup files. This can be done by using one of the supported variables into the application resource files. Below is a list of supported variables and their substitutions:\n\n-\t${ARTIFACT}: the projects artifact id (atom)\n-\t${DESCRIPTION}: the projects description (string)\n-\t${ID}: the projects id (string)\n-\t${VERSION}: the projects version (string)\n-\t${MODULES}: all compiled .beam files found in the target ebin folder (list)\n-\t${REGISTERED}: all registered names, based on the -registered(Names). attribute retrieved from the compiled .beam files (list)\n-\t${APPLICATIONS}: all dependency applications of the project as configured in the project\'s pom.xml (string)\n\nThe resulting application resource file as well as the application upgrade file will be checked for plausability.\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "package-release".equals( goal ) )
        {
            append( sb, "erlang:package-release", 0 );
            append( sb, "This Mojo packages/creates a release .tar.gz using the erlang systools modules. The build can be customized by providing additional options through the tarOptions parameter.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );

                append( sb, "includeErts (Default: false)", 2 );
                append( sb, "Setting this to true will include the backend node\'s erlang emulator into the release package.\n\nNote: The resulting package is then highly system dependent since it contains the erlang emulator (C code) from the backend nodes erlang installation.\n", 3 );
                append( sb, "Expression: ${includeErts}", 3 );
                append( sb, "", 0 );

                append( sb, "tarOptions", 2 );
                append( sb, "Additional options for systools:make_tar/2 (comma separated). Note: The silent option is passed by the plugin, do not overwrite.", 3 );
                append( sb, "Expression: ${tarOptions}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "reload-dependencies".equals( goal ) )
        {
            append( sb, "erlang:reload-dependencies", 0 );
            append( sb, "Mojo that first purges all dynamically loaded modules on the backend node and reloads the modules provided by (unpacked) dependencies.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "reload-release-dependencies".equals( goal ) )
        {
            append( sb, "erlang:reload-release-dependencies", 0 );
            append( sb, "Mojo that first purges all dynamically loaded modules on the backend node and reloads the modules provided by (unpacked) dependencies.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "reload-test-dependencies".equals( goal ) )
        {
            append( sb, "erlang:reload-test-dependencies", 0 );
            append( sb, "Mojo that first purges all dynamically loaded modules on the test backend node and reloads the modules provided by (unpacked) dependencies.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );

                append( sb, "skipTests (Default: false)", 2 );
                append( sb, "Setting this to true will skip the test dependency loading.", 3 );
                append( sb, "Expression: ${skipTests}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "run".equals( goal ) )
        {
            append( sb, "erlang:run", 0 );
            append( sb, "A Mojo that runs erlang applications packaged with packaging type PackagingType.ERLANG_OTP or PackagingType.ERLANG_STD on a specific (remote) node. This will start the application with all dependent applications and all modules pre-loaded. When finished the Mojo will stop and unload the started applications.\n\nTODO: release projects cannot be run\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );

                append( sb, "remote", 2 );
                append( sb, "The name of the node to run the application on.\n\nNote: The cookie of the remote node has to be set accordingly using the cookie parameter.\n", 3 );
                append( sb, "Expression: ${remote}", 3 );
                append( sb, "", 0 );

                append( sb, "withDependencies (Default: false)", 2 );
                append( sb, "Setting this to true will also upload all modules from the (maven) dependencies on the remote node before starting the application.", 3 );
                append( sb, "Expression: ${withDependencies}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "setup".equals( goal ) )
        {
            append( sb, "erlang:setup", 0 );
            append( sb, "Utility goal that will setup a new Erlang/OTP Maven project, creating the basic resources and folders required, from a best practice point of view.\n\nThis will typically replace the functionality given by a Maven archetype, checking and creating any missing resource. Regarding erlang/OTP applications this could be:\n\n-\tsource folder\n-\tapplication resource file [artifactId].app\n-\tapplication upgrade file [artifactId].appup\n-\tinclude folder\n-\tpriv folder\n-\ttest source folder\n-\ttest include folder\n-\ttest priv folder\n\nRegarding erlang/OTP releases this could be:\n\n-\trelease file [artifactId].rel\n-\tsystem configuration sys.config\n\nBy default some extras for project management are also generated:\n\n-\tsite folder with site.xml\n-\tapt source folder with index.apt[.vm]\n-\tchangelog folder with changes.xml\n\nThe default application resource file will look like (this would be sufficient for library applications):\n\n{application,\u00a0${ARTIFACT},\n\u00a0[{description,\u00a0${DESCRIPTION}},\n\u00a0\u00a0{id,\u00a0${ID}},\n\u00a0\u00a0\u00a0{vsn,\u00a0${VERSION}},\n\u00a0\u00a0\u00a0{modules,\u00a0${MODULES}},\n\u00a0\u00a0\u00a0{maxT,\u00a0infinity},\n\u00a0\u00a0\u00a0{registered,\u00a0${REGISTERED}},\n\u00a0\u00a0\u00a0{included_applications,\u00a0[]},\n\u00a0\u00a0\u00a0{applications,\u00a0[kernel,\u00a0stdlib]},\n\u00a0\u00a0\u00a0{env,\u00a0[]},\u00a0\n\u00a0\u00a0\u00a0{start_phases,\u00a0[]}]}.\n\n\n\nThe default application upgrade file will look like:\n\n{${VERSION},\u00a0[EDIT\u00a0HERE],\u00a0[EDIT\u00a0HERE]}.\n\n\n\nThe default release file will look like:\n\n{release,\n\u00a0{${ARTIFACT},\u00a0${VERSION}},\n\u00a0${ERTS},\n\u00a0${AUTODEPS}}.\n\n\n\nThe default release upgrade file will look like:\n\n{${VERSION},\u00a0[EDIT\u00a0HERE],\u00a0[EDIT\u00a0HERE]}.\n\n\n\nThe default system configuration file will look like:\n\n[].\n\n\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );

                append( sb, "withExtras (Default: true)", 2 );
                append( sb, "Setting this to false will skip generation of the project resources considered best-practice extras - such as Maven site definition XML document, an index APT page and a changes XML document for the maven-changes-plugin. It is of course encouraged to leave this as defined by default.", 3 );
                append( sb, "Expression: ${withExtras}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "show-build-info".equals( goal ) )
        {
            append( sb, "erlang:show-build-info", 0 );
            append( sb, "This Mojo outputs the build information ascertained by maven to compile Erlang sources. The output is supposed to enable other tools (like emacs) to reconstruct compilation commands.\n\nThe output is logged at info level and contains:\n\n-\tsource folder for main erlang sources\n-\tsource folder for unit-test erlang sources\n-\tinclude directories that may contain erlang header files\n-\tcode path directories including those of dependend projects in the target directory of the maven build\nThe output consists of one line per item. Each item consists of two elements: InfoType \': \' InfoValue where InfoType is one of:\n-\tsrc_dir\n-\ttest_src_dir\n-\tinclude_dir\n-\tcode_path\nInfoValue is a file path. Both elements a seperated by the string \': \' (colon, space).\n\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "target-system".equals( goal ) )
        {
            append( sb, "erlang:target-system", 0 );
            append( sb, "This Mojo creates a target system release package .tar.gz according to the official documentation. If there\'s no sys.config file found a default empty one will be included. The resulting target system depends on a correct root directory configuration. The plug-in will change the scripts to check for the ${ ARTIFACTID_TOP} (upper case) environment variable. This variable must be set by the user to guarantee a proper system behaviour. Example: If artifact id is release the environment variable ${RELEASE_TOP} must be set.\n\nNote: The resulting target system is highly system dependent since it contains the erlang emulator (C code) from the backend nodes erlang installation.\n\nNote: This mojo is currently working but still in experimental stage.\n\n-\tFIXME not supported on Microsoft Windows\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "test".equals( goal ) )
        {
            append( sb, "erlang:test", 0 );
            append( sb, "A Mojo that runs test modules using eunit.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );

                append( sb, "skipTests (Default: false)", 2 );
                append( sb, "Setting this to true will skip the test compilation.", 3 );
                append( sb, "Expression: ${skipTests}", 3 );
                append( sb, "", 0 );

                append( sb, "test", 2 );
                append( sb, "Setting this to a module name, will only run this test case.", 3 );
                append( sb, "Expression: ${test}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "test-compile".equals( goal ) )
        {
            append( sb, "erlang:test-compile", 0 );
            append( sb, "Compile erlang test sources and recompile erlang sources with the options debug_info, export_all and {d, \'TEST\'}. This will also compile the supporting erlang sources provided along with the plugin.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );

                append( sb, "skipTests (Default: false)", 2 );
                append( sb, "Setting this to true will skip the test compilation.", 3 );
                append( sb, "Expression: ${skipTests}", 3 );
                append( sb, "", 0 );

                append( sb, "testCompilerOptions", 2 );
                append( sb, "Additional compiler options (comma separated) for test compilation that are directly passed to compile:file/2, e.g. \'{d, Macro}, nowarn_unused_function\'. Note: The user may not specifiy one of the report options since the Mojo itself uses the return option internally. Warnings and Errors will be printed without specifying extra options.", 3 );
                append( sb, "Expression: ${testCompilerOptions}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "test-initialize".equals( goal ) )
        {
            append( sb, "erlang:test-initialize", 0 );
            append( sb, "Mojo that starts the test erlang node used as a backend for rpcs made by the plugin. The node will only be started if it is not already running. The node will be shutdown when the executing JVM exits. This is done by a Runtime.addShutdownHook() which will only be added once each JVM execution.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );

                append( sb, "skipTests (Default: false)", 2 );
                append( sb, "Setting this to true will skip the test initialization.", 3 );
                append( sb, "Expression: ${skipTests}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "test-release".equals( goal ) )
        {
            append( sb, "erlang:test-release", 0 );
            append( sb, "This Mojo checks the release file for plausability. This is done by checking the release version, the release name as well as checking all dependencies for correct versioning and existence.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );

                append( sb, "otpRelease", 2 );
                append( sb, "This must be set to the erlang/OTP release version this release has to be based on. The version must be given as it would be returned by erlang:system_info(otp_release). All standard OTP dependencies like kernel, stdlib, ... will be configured to the version of the configured erlang/OTP release.\n\nIn order to do this the executing backend node has to run the required OTP release. Release packaging will fail if the backend node doesn\'t do so unless the skipReleaseTest parameter is specified.\n", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${otpRelease}", 3 );
                append( sb, "", 0 );

                append( sb, "skipReleaseTest (Default: false)", 2 );
                append( sb, "Setting this to true will will skip comparison of the OTP release version against the required OTP version. The release build will fail if the backend node doesn\'t run the required erlang/OTP release specified by otpRelease.", 3 );
                append( sb, "Expression: ${skipReleaseTest}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "upload".equals( goal ) )
        {
            append( sb, "erlang:upload", 0 );
            append( sb, "This Mojo uploads a project onto a remote node. In case of application projects this includes remote loading of the compiled application modules loading of the application resource file using application:load/1. The modules will be purged once as if c:c/1 would have been called on a shell. In case of a release project the release package (.tar.gz) will be uploaded in the remote nodes releases directory ready to be unpacked and installed using the release_handler.\n\nNote: Uploading of releases will require that the remote erlang process has write access to its releases directory.\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );

                append( sb, "remote", 2 );
                append( sb, "The name of the node to upload the compiled code to.\n\nNote: The cookie of the remote node has to be set accordingly using the cookie parameter.\n", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${remote}", 3 );
                append( sb, "", 0 );

                append( sb, "withDependencies (Default: false)", 2 );
                append( sb, "Setting this to true will also upload all modules from the (maven) dependencies on the remote node. This parameter is ignored when uploading release projects.", 3 );
                append( sb, "Expression: ${withDependencies}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "upload-tests".equals( goal ) )
        {
            append( sb, "erlang:upload-tests", 0 );
            append( sb, "This Mojo uploads an application\'s modules compiled for test execution and the application\'s tests onto a remote node. This will not upload the application\'s resource files. The modules will be purged once as if c:c/1 would have been called on a shell.\n", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "cookie", 2 );
                append( sb, "The cookie to use for the java and the backend node.", 3 );
                append( sb, "Expression: ${cookie}", 3 );
                append( sb, "", 0 );

                append( sb, "erlCommand", 2 );
                append( sb, "The erlang command used to start an erlang backend node. The path must exist and the destination must be executable. If the given command does not fullfill these requirements erl is used (assuming the command is part of the hosts PATH). The path must not contain any arguments.", 3 );
                append( sb, "Expression: ${erlCommand}", 3 );
                append( sb, "", 0 );

                append( sb, "remote", 2 );
                append( sb, "The name of the node to upload the compiled code to.\n\nNote: The cookie of the remote node has to be set accordingly using the cookie parameter.\n", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${remote}", 3 );
                append( sb, "", 0 );

                append( sb, "withDependencies (Default: false)", 2 );
                append( sb, "Setting this to true will also upload all modules from the (maven) dependencies on the remote node.", 3 );
                append( sb, "Expression: ${withDependencies}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
